//############################################################################
//Minumum einer Liste
//@author diehl@ins.uni-bonn.de
//@date 10-2013
//###########################################################################

#include <stdlib.h>
#include <stdio.h>

/**@struct Element einer Liste
 * @var value Wert im Element in der Liste
 * @var next Pointer zum nächsten Element in der Liste
 */
struct element
{
  int value;
  struct element *next;
};


/** Methode fügt das Element value an das Ende der Liste an.
 * @param l Zeiger auf die Liste
 * @param value Wert, der eingefügt werden soll
 */
void
append (struct element **l, int value)
{

  struct element *tmp = *l;

  struct element *new = (struct element *) malloc (sizeof (struct element *));
  new->value = value;
  new->next = NULL;


  if (tmp == NULL)
    *l = new;

  else
    {

      while (tmp->next != NULL)
	{
	  tmp = tmp->next;
	}
      tmp->next = new;
    }

}

/**Methode löscht alle Elemente der Liste
 * @param l Pointer zum ersten Element der Listen
 */
void
delete (struct element *l)
{

  struct element *tmp = l->next;

  while (l->next != NULL)
    {
      tmp = l->next;
      l->next = tmp->next;
      free (tmp);
    }
  free (l);

}


int
main (void)
{

  struct element *liste = NULL;

  append (&liste, 2);
  append (&liste, 5);
  append (&liste, 7);
  append (&liste, 1);
  append (&liste, 9);
  append (&liste, 8);
  append (&liste, 6);
  append (&liste, 3);
  append (&liste, 4);

  int max = liste->value;
  struct element *tmp = liste->next;

  while (tmp->next != NULL)
    {

      tmp = tmp->next;
      if (tmp->value > max)
	max = tmp->value;

    }

  printf ("Maximum: %d \n", max);

  delete (liste);

  return 0;
}
